import os
import csv
import urllib
from urllib.request import Request

import requests
from urllib3.exceptions import NewConnectionError, MaxRetryError
import itertools


def build_request():
    with open(f"{os.getcwd()}/arcg_meta.csv", newline="") as file:
        rfile = csv.DictReader(file)
        failed = []
        for row in itertools.islice(rfile, 3, 3436): # here random
            book_url = row.get("file_link")
            book_id = row.get("id")
            try:
                urllib.request.urlretrieve(book_url, f"{book_id}.pdf")
            except (Exception, urllib.request.HTTPError, MaxRetryError,
                    NewConnectionError, requests.exceptions.ProxyError) as Error:
                with open("logs.txt", "w") as error_file:
                    failed.append(book_id)
                    error_file.write(f"failed: {failed}")
                    print(Error)
                    continue
        print("Done")


if __name__ == "__main__":
    build_request()
